<template lang="pug">
	tarjeta.detalleArchivo(v-if="fichero.id", titulo="Archivo", estado="activo", :expandir="true",  :class="{editar}")
		.cartel
			.imagen()
				figure.miniatura( v-if="miniatura", @click.stop="ver( fichero.id )" )
					img( :src="miniatura", :alt="fichero.nombre", ref="miniatura" )

				IconoFichero( v-else, :ext="fichero.tipo", @click.stop="ver( fichero.id )" )
				.cambiar( v-if="editar" )
					input#foto( type="file", ref="foto", @change="fotoChange" )
					span Cambiar Imagen
			h3.nombre
				.campo( v-if="editar" )
					input(type = "text", v-model="fichero.nombre", placeholder="Nombre *")
					span.tipo .{{ fichero.tipo }}
				span( v-else ) {{ fichero.nombre }}.{{ fichero.tipo }}
			.descripcion
				.campo( v-if="editar" ): input(type="text", v-model="fichero.descripcion", placeholder="Descripción")
				span( v-else ) {{fichero.descripcion}}
			.categoria( v-if="editar" )
				.campo
					select( name="categoria", v-model="categoriaPrincipal", id="categoria" )
						option( disabled, selected, value="0" ) Elije una categoria
						option( v-for="cat in categorias", :value="cat.id" ) {{ cat.nombre }}
					select( name="subcategoria", v-model="categoriaSecundaria", id="subcategoria" )
						option( disabled, selected, value="0" ) Elije una subcategoria
						option( v-for="scat in subcategorias", :value="scat.id" ) {{ scat.nombre }}
			.categoria( v-else )
				span(v-if="categoria.superior") {{categoria.superior.nombre}}&nbsp;>&nbsp;
				span {{categoria.nombre}}
		.acciones
			button.eliminar(
				type="button",
				v-tooltip="'Eliminar'",
				@click.stop="borrar(fichero.id)"
				)
				vector( src="~@img/ico-borrar.svg?inline")
			button.editar(
				type="button",
				v-tooltip="'Editar'",
				:class="{ marcado: editar }"
				@click.prevent="editar = !editar"
				)
				vector( src="@img/edit.svg?inline")
			button.guardar(
				type="button"
				v-tooltip="'Guardar'",
				v-if="editar"
				@click.prevent="guadar"
				)
				vector( src="@img/ico-guardar.svg?inline")
			button.favorito(
				type="button",
				v-tooltip="'Marcar como favorito.'",
				@click.stop="marcar( fichero.id )",
				:class="{ marcado: favorito }"
				)
				vector( src="@img/ico-favorito.svg?inline")
			button.descargar(
				type="button"
				v-tooltip="'descargar'",
				@click.stop="descargar( fichero.id )"
				)
				vector( src="@img/ico-descargar.svg?inline")
			button( type="button", v-if="tienePrevio(fichero.tipo)", @click.stop="ver( fichero.id )" ).ver: vector( src="@img/ico-ver.svg?inline")
			//-button( type="button" ).compartir: vector( src="@img/ico-compartir.svg?inline")

		dl.propiedades
			//-dt Propietario:
			//-dd {{ fichero.propietario }}
			dt Último acceso:
			dd {{ fichero.modificado }}
			//-dt Compartido:
			//-dd {{ fichero.compartido }}

		.etiquetas
			tags-input.editorEtiquetas(
				v-if="editar"
				element-id="etiquetasEdicion",
				placeholder="Agrega una etiqueta"
				:add-tags-on-comma="true"
				v-model="etiquetasSelecionadas",
				:existing-tags="etiquetasExistentes",
				:typeahead="true"
				@tags-updated="etiquetasActualizadas")
			router-link.etiqueta(
				v-else
				v-for="etiqueta in fichero.etiquetas",
				:key="id",
				:to="{ name: 'etiqueta', params: { id: etiqueta.id }}"
				tag="div"
				)
				span {{ etiqueta.nombre | capitalizar }}
		//- pre {{ etiquetas }}
		//- pre {{ etiquetasFichero }}

	//- modal.previo(
			v-if="fichero.id",
			name="previoDetalleArchivo",
			:max-width="640",
			:max-height="640",
			:adaptive="true",
			width="80%",
			height="90%"
			)
			button.cerrar(
				type="button",
				@click="$modal.hide('previoDetalle')" ) &times;
			figure( v-if="fichero.id && esImagen(fichero.tipo)" )
				img( :src="previo( fichero.id )", :alt="fichero.descripcion")
			video( v-if="fichero.id && esVideo(fichero.tipo)", "controls", "autoplay" )
				source( :src="previo( fichero.id )", :type="'video/'+fichero.tipo")
			iframe( v-if="fichero.id && esArchivo(fichero.tipo)", :src="previo( fichero.id )", "sandbox")

</template>

<script>
	import Tarjeta from "@/components/Tarjeta";
	import IconoFichero from "@/components/IconoFichero";
	import ItemCampo from "@/components/ItemCampo";
	import { archivos } from "@/api";
	import { mapActions, mapGetters, mapState } from "vuex";

	export default {
		name: "DetalleArchivo",
		data() {
			return {
				editar: false,
				subcategoria: 0,
				miniatura: "",
				etiquetasIds: [],
				etiquetasNuevas: [],
				etiquetasSelecionadas: [],
				//subcategorias: []
			};
		},
		components: {
			Tarjeta,
			ItemCampo,
			IconoFichero
		},
		props: {
			archivo: {
				type: Object,
				default: () => {
					return { id: 0 };
				}
			}
		},
		watch: {
			fichero(nuevo) {
				console.log("watch", "fichero", nuevo);
				//console.log(this.$el);
				this.$el.scrollIntoView({
					behavior: "smooth",
					block: "start"
				});
				if (nuevo.miniatura) {
					this.miniatura = nuevo.miniatura;
				} else {
					this.miniatura = "";
				}

				this.etiquetasSelecionadas = this.etiquetasFichero;
			},
		},
		computed: {
			fichero() {
				if( this.archivo ){
					return this.archivo;
				}else{
					return { id: 0 };
				}
			},
			favorito() {
				return this.esFavorito(this.fichero.id);
			},
			categoria() {
				let icat = { nombre: "" };
				this.categorias.forEach(cat => {
					if (cat.id == this.fichero.categoria) {
						icat = Object.assign({}, cat);
						icat.superior = false;
					} else if (cat.descendientes) {
						let sub = cat.descendientes.find(
							subcat => subcat.id == this.fichero.categoria
						);
						if (sub) {
							let subcat = Object.assign({}, sub);
							icat = subcat;
							icat.superior = cat;
						}
					}
				});
				return icat;
			},
			categoriaPrincipal: {
				get() {
					return this.categoria.superior
						? this.categoria.superior.id
						: this.categoria.id;
				},
				set(id) {
					this.fichero.categoria = id;
				}
			},
			categoriaSecundaria: {
				get() {
					return this.categoria.superior ? this.categoria.id : 0;
				},
				set(id) {
					this.fichero.categoria = id;
				}
			},
			subcategorias() {
				let cat = this.categorias.find(
					e => e.id == this.categoriaPrincipal
				);
				if (cat) {
					return cat.descendientes;
				} else {
					return [];
				}
			},
			etiquetasFichero(){
				// let etiquetas = {};

				// this.fichero
				// 	.etiquetas.forEach(e => {
				// 		etiquetas[e.id] = e.nombre;
				// 	});

				// let etiquetas = this.fichero
				// 	.etiquetas.map(e => {
				// 		return { key: e.id, value:e.nombre};
				// 	});

				let etiquetas = this.fichero
					.etiquetas.map(e => {
						return e.nombre;
					});

				return etiquetas;
			},
			etiquetasExistentes(){
				// let etiquetas = {};

				// this.fichero
				// 	.etiquetas.forEach(e => {
				// 		etiquetas[e.id] = e.nombre;
				// 	});

				// let etiquetas = [];
				// for (const key in this.etiquetas) {
				// 	etiquetas.push({ key, value: this.etiquetas[key]})
				// }

				return this.etiquetas;
			},
			...mapGetters(["esFavorito", "previo"]),
			...mapState(["categorias", "etiquetas"])
		},
		methods: {
			esImagen(tipo) {
				const imagenes = ["jpg", "png", "webp", "gif", "psd"];
				return imagenes.includes(tipo.toLowerCase());
			},
			esVideo(tipo) {
				const videos = ["mp4"];
				return videos.includes(tipo.toLowerCase());
			},
			esArchivo(tipo) {
				const archivos = ["pdf"];
				return archivos.includes(tipo.toLowerCase());
			},
			tienePrevio(tipo) {
				return (
					this.esImagen(tipo) ||
					this.esVideo(tipo) ||
					this.esArchivo(tipo)
				);
			},
			borrar(id) {
				let rpta = confirm(
					`Vas a eliminar el archivo "${this.fichero.nombre}.${
						this.fichero.tipo
					}"\nEsta operación no se puede revertir.`
				);
				//console.log(rpta);
				if (rpta) {
					this.borrarArchivo({ id });
					this.$root.$emit("archivo-actualizado");
				}
			},
			marcar(id) {
				this.marcarArchivo({ id, marcar: !this.favorito });
			},
			descargar(id) {
				archivos.descargar(id);
			},
			ver() {
				this.$root.$emit("archivo-previo", this.archivo);
				//this.$modal.show("previoDetalleArchivo");
			},
			guadar() {
				let f = Object.assign({}, this.fichero);
				f = Object.assign(f, { etiquetas: {
							ids: this.etiquetasIds,
							nuevas: this.etiquetasNuevas
						}});
				if (this.miniatura != this.fichero.miniatura) {
					f.miniatura = this.miniatura;
				}
				archivos.actualizar(f).then(
					r => {
						this.editar = false;
						this.fichero.miniatura = this.miniatura;
						this.$root.$emit("archivo-actualizado");
						this.obtenerArchivo({ id:this.fichero.id });
					},
					error => {
						console.log(error);
					}
				);
			},
			fotoChange() {
				if (this.$refs.foto.files.length) {
					var imagen = new FileReader();
					imagen.onload = () => {
						this.redimensionar(imagen.result).then(
							img => (this.miniatura = img)
						);
					};
					imagen.readAsDataURL(this.$refs.foto.files[0]);
					//imagen.readAsDataURL( this.archivo );
				}
			},
			redimensionar(dataurl, tamaño = 640, calidad = 0.9) {
				const D = document;
				return new Promise((resolver, rechazar) => {
					const img = D.createElement("img");
					const canvas = D.createElement("canvas");
					const ctx = canvas.getContext("2d");

					//console.log( "retrollamada", retrollamada );
					img.src = dataurl;
					img.onload = function() {
						const proporcion = img.naturalHeight / img.naturalWidth;

						const medida = Math.min(
							Math.max(img.naturalWidth, img.naturalHeight),
							tamaño
						);

						if (proporcion < 1) {
							canvas.width = medida;
							canvas.height = Math.round(medida * proporcion);
						} else {
							canvas.width = Math.round(medida / proporcion);
							canvas.height = medida;
						}
						ctx.drawImage(img, 0, 0, canvas.width, canvas.height);

						resolver(canvas.toDataURL("image/jpeg", calidad));
					};
				});
			},
			etiquetasActualizadas() {
				console.debug(
					"etiquetasActualizadas",
					this.etiquetasSelecionadas.length
				);

				this.etiquetasIds = [];
				this.etiquetasNuevas = [];

				this.etiquetasSelecionadas.forEach( t =>{
					let nueva = true;
					for (const id in this.etiquetas) {
						if (this.etiquetas[id] == t) {
							this.etiquetasIds.push(id);
							nueva = false;
						}
					}
					if (nueva) {
						this.etiquetasNuevas.push(t);
					}
				});

				// this.etiquetasIds = this.etiquetasSelecionadas.filter(item =>
				// 	parseInt(item)
				// );
				// this.etiquetasNuevas = this.etiquetasSelecionadas.filter(
				// 	item => !parseInt(item)
				// );
			},
			...mapActions(["marcarArchivo", "obtenerArchivo", "borrarArchivo", "obtenerArchivo"])
		},
		mounted() {
			this.$nextTick(function() {
				//console.log("mounted", this.$el);
				//console.log("mounted", this.$el);
				if (this.fichero.id) {
					this.$el.scrollIntoView({
						behavior: "smooth",
						block: "start"
					});

				}
				this.etiquetasSelecionadas = this.etiquetasFichero;
			});


			if (this.fichero.miniatura) {
				this.miniatura = this.fichero.miniatura;
			} else {
				this.miniatura = "";
			}
		},
		// update() {
		// 	console.group("DetalleArchivo update")
		// 	console.debug(this.fichero.id);
		// 	console.groupEnd();
		// },
		// beforeUpdate() {
		// 	console.group("DetalleArchivo beforeUpdate")
		// 	console.debug(this.fichero.id);
		// 	console.groupEnd();
		// },
		// beforeMount() {
		// 	console.group("DetalleArchivo beforeMount")
		// 	console.debug(this.fichero.id);
		// 	console.groupEnd();
		// },
		// created() {
		// 	console.group("DetalleArchivo created")
		// 	console.debug(this.fichero.id);
		// 	console.groupEnd();
		// },
		// beforeCreate() {
		// 	console.group("DetalleArchivo beforeCreate")
		// 	console.debug(this.fichero.id);
		// 	console.groupEnd();
		// }
	};
</script>

<style lang="stylus" scoped>
	@import "~nib/index"
	@import "../stylus/base/utiles.styl"

	.detalleArchivo
		width 25vw

	.cartel
		display grid
		grid-template-areas "imagen" "nombre" "descripcion" "categoria"
		grid-gap .5rem
		grid-template-columns auto
		margin-bottom .5rem

		h3
			font-size calcRem( 14 )
			font-weight bolder
			color tint( azul, 30% )
			display flex
			align-items center

		p
			margin 0
			font-size calcRem( 12 )
			display flex

		span
			flex 0 1 auto
			display block

			&.tipo
				flex 0 0 auto

		.nombre
			grid-area nombre

		.imagen
			grid-area imagen
			display flex
			flex-direction column
			// background-color gris_super_claro

		.descripcion
			grid-area descripcion
			margin 0
			font-size calcRem( 12 )
			display flex

		.categoria
			grid-area categoria
			margin 0
			font-size calcRem( 14 )
			display flex
			color tint( azul, 30% )

		.iconoFichero
			width 48px
			margin auto
			cursor pointer

		.miniatura
			width 100%
			width 100%
			position relative
			cursor pointer

			&::before
				content ""
				display block
				padding-top 100%

			img
				absolute top left right bottom
				width 100%
				height 100%
				object-fit cover

		.cambiar
			background-color tint( azul, 40% )
			display none
			width auto
			padding .5em
			font-size calcRem( 14 )
			color blanco
			position relative
			cursor pointer
			opacity 1
			cursor pointer

			.expandido &
				display block

			&:hover
				opacity 1
				background-color tint( azul, 20% )

			input
				absolute top left right bottom
				width 100%
				height 100%
				opacity 0
				cursor pointer

			span
				display block
				text-align center

		.campo
			flex 1 1 auto
			font-size calcRem( 12 )
			display flex
			align-items center
			min-width 80px
			color gris
			overflow hidden

			input,
			select
				display block
				padding .5em .3em
				border none
				outline none
				width 100%
				color inherit
				font-size inherit
				line-height 1
				border 1px solid lighten( gris, 50% )
				border-radius .3rem

	.contenido
		padding 1rem
		color gris
		background-color tint( azul, 80% )

	.propiedades
		display grid
		grid-template-columns auto 1fr
		grid-column-gap 1em
		grid-row-gap .5em
		align-items end
		font-size calcRem( 12 )
		font-weight 300

		dt
			flex 1 0 50%
			font-weight bolder
			color tint( azul, 50% )

		dd
			flex 1 1 auto

	h4
		color tint( azul, 50% )
		font-size calcRem( 12 )
		margin-bottom .5rem

	p
		font-size calcRem( 10 )
		line-height 1.2
		font-weight 300
		margin-bottom 1em

	&.comentarios
		>>> .contenido
			background-color #fff
			padding 0

	.listaComentarios
		padding .5rem

		.itemComentario
			margin-bottom .5rem

	.comentar
		display grid
		grid-template-areas "texto texto texto" "foto nombre boton"
		grid-template-columns min-content 1fr 1fr
		grid-template-rows min-content min-content
		grid-gap .2rem .5rem
		align-items center

		textarea
			grid-area texto
			font-size calcRem( 10 )
			font-weight 300
			padding 1em
			background-color #F2F2F2
			border 1px solid #E6E6E6
			width 100%
			height 6em
			display block
			resize vertical

		figure
			align-self start
			grid-area foto
			width 48px
			height 48px
			border-radius 48px
			box-sizing border-box
			border 2px solid blanco
			background-color tint( azul, 60% )
			overflow hidden
			margin-left 1rem

		h3
			grid-area nombre
			text-align left
			color darken( gris, 50% )
			font-weight 500
			font-size calcRem( 10 )

		button
			grid-area boton
			font-size calcRem( 10 )
			font-weight 500
			line-height 1
			color blanco
			background-color tint( azul, 30% )
			border none
			padding .6rem .8rem
			border-radius 2rem

	.acciones
		flex 0 1 auto
		display flex
		justify-content flex-end
		margin-bottom .5rem

		button
			flex 0 0 32px
			border none
			width 32px
			height 32px
			border-radius 1rem
			display flex
			align-items center
			justify-content center
			padding 0
			margin 0 .1rem
			cursor pointer
			color tint( azul, 40% )
			background-color transparente

			&:hover
				background-color tint( azul, 90% )

			.vector
				height 20px

				svg
					display block

			&.marcado
				background-color tint( azul, 50% )
				color blanco

		.eliminar
			color tint( rojo, 40% )

	.etiquetas
		margin-top .5rem
		display flex
		flex-wrap wrap

		.etiqueta
			flex 1 0 auto
			margin .2rem
			padding .2rem .4rem
			background-color tint( azul, 70% )
			// border 1px solid tint( azul, 70% )
			border-radius 1rem
			text-align center
			line-height 1.3
			font-size calcRem( 10 )
			cursor pointer
			color blanco

			&:hover
				background-color alpha( tint( azul, 20% ), 50% )

			&.activo
				background-color hover_lateral

	.previo
		.cerrar
			absolute top right
			padding .2rem .4rem
			color tint( azul, 40% )
			background-color blanco
			font-size 1.5rem
			cursor pointer
			font-weight bold
			z-index 1

		video
			absolute top left right bottom
			width 100%
			height 100%

		iframe
			absolute top left right bottom
			width 100%
			height 100%

		figure
			absolute top left right bottom
			display flex
			align-items center
			z-index 0
			background-size 32px
			background-position center
			background-image url( "/img/cargando.gif" )

			img
				max-width 100%
				max-height 100%

	.etiquetas
		display flex
		align-items center
		background-color transparente

		> div
			flex-grow 1

	.editorEtiquetas
		min-height 4rem

		>>>.tags-input
			display flex
			align-items center
			border none
			border: 1px solid #adadad;
			border-radius: 0.3rem;
			padding: 0.2em 0.3em;
			flex-wrap wrap
			background-color blanco

			input
				display: block;
				border: none;
				outline: none;
				width: 100%;
				color: inherit;
				font-size: inherit;
				line-height: 1;
				margin-righ: .5rem

			.tags-input-remove
				cursor pointer
				position relative
				display inline-block
				width .5rem
				height .5rem
				overflow hidden

			.tags-input-remove:before,
			.tags-input-remove:after
				content ""
				position absolute
				width 100%
				top 50%
				left 0
				background-color tint( azul, 50% )
				height 2px
				margin-top -1px

			.tags-input-remove:before
				transform rotate( 45deg )

			.tags-input-remove:after
				transform rotate( -45deg )

			input:focus
				outline none

			input[type="text"]
				color #495057


			.tags-input-badge
				background-color tint( azul, 90% )
				white-space: nowrap
				padding .2em .5em
				margin-right .2em
				border-radius .2em

			.badge-light
				color darken( gris, 30% )
				background-color tint( azul, 90% )

			.badge-light[href]:focus,
			.badge-light[href]:hover
				color darken( gris, 30% )
				text-decoration none
				background-color tint( azul, 80% )

		>>> div
			.typeahead-badges
				margin .5rem
				//background-color tint( azul, 80% )
				padding .2rem 0
				display: flex
				flex-wrap: wrap

				.tags-input-badge

					color #fff
					background-color tint( azul, 50% )
					margin .2rem .3rem
					padding .2rem .5em
					border-radius .2em

				.tags-input-typeahead-item-highlighted-default
					background-color tint( azul, 10% )



</style>
